#include <Adafruit_NeoPixel.h>
#include <Adafruit_CircuitPlayground.h>

#define SERIESRESISTOR 10000
#define CPLAY_THERMISTORPIN A9
#define TEMPERATURENOMINAL 25
#define BCOEFFICIENT 3380
#define THERMISTORNOMINAL 10000

// Template ID, Device Name and Auth Token are provided by the Blynk.Cloud
// See the Device Info tab, or Template settings
#define BLYNK_TEMPLATE_ID "put your own data"
#define BLYNK_DEVICE_NAME "put your own data"
#define BLYNK_AUTH_TOKEN "put your own data"

// Comment this out to disable prints and save space
#define BLYNK_PRINT SerialUSB
#include <ESP8266_Lib.h>
#include <BlynkSimpleShieldEsp8266.h>

char auth[] = BLYNK_AUTH_TOKEN;

// Your WiFi credentials.
// Set password to "" for open networks.
char ssid[] = "put your own data";
char pass[] = "put your own data";

// Hardware Serial on Mega, Leonardo, Micro...
#define EspSerial Serial1

// or Software Serial on Uno, Nano...
//#include <SoftwareSerial.h>
//SoftwareSerial EspSerial(2, 3); // RX, TX
// Your ESP8266 baud rate:
#define ESP8266_BAUD 115200
ESP8266 wifi(&EspSerial);
#define LED_PIN 8
#define LED_COUNT 10

//celebrate song
// Length of time in milliseconds of a whole note (i.e. a full bar)
#define WHOLE 2200
#define HALF WHOLE/2
#define QUARTER HALF/2
#define EIGHTH QUARTER/2
#define EIGHTH_TRIPLE QUARTER/3
#define SIXTEENTH EIGHTH/2

Adafruit_NeoPixel strip(LED_COUNT, LED_PIN, NEO_GRB + NEO_KHZ800);

float getTemperature(void){
  double reading;
  reading = analogRead(CPLAY_THERMISTORPIN);
  reading = ((1023.0 * SERIESRESISTOR) / reading);
  reading -= SERIESRESISTOR;
  double steinhart;
  steinhart = reading / THERMISTORNOMINAL;
  steinhart = log(steinhart);
  steinhart /= BCOEFFICIENT;
  steinhart += 1.0 / (TEMPERATURENOMINAL + 273.15);
  steinhart = 1.0 / steinhart;
  steinhart -= 273.15;
  return steinhart;
}

void makeNotificationFlame(void){
  for(int i = 0; i < 10; i++){
    strip.setPixelColor(i, 255, 0, 0);
    strip.show();
  }   
  CircuitPlayground.playTone(392, EIGHTH_TRIPLE + EIGHTH_TRIPLE/32, false);
  CircuitPlayground.playTone(523, EIGHTH_TRIPLE + EIGHTH_TRIPLE/32, false);
  CircuitPlayground.playTone(659, EIGHTH_TRIPLE + EIGHTH_TRIPLE/32, false);
  CircuitPlayground.playTone(784, EIGHTH + EIGHTH/32, false);
  CircuitPlayground.playTone(659, SIXTEENTH + SIXTEENTH/32, false);
  CircuitPlayground.playTone(784, HALF + HALF/32, false);
    
  delay(900);
} 

void setup()
{
  // Debug console
  SerialUSB.begin(115200);
  // Set ESP8266 baud rate
  EspSerial.begin(ESP8266_BAUD);
  delay(10);
  strip.begin();
  strip.show();
  strip.setBrightness(50);
  delay(100);
  Blynk.begin(auth, wifi, ssid, pass);
  // You can also specify server:
  //Blynk.begin(auth, wifi, ssid, pass, "blynk.cloud", 80);
  //Blynk.begin(auth, wifi, ssid, pass, IPAddress(192,168,1,100), 8080);
}

unsigned long lastUpdated = 0;
void loop()
{
  Blynk.run();
  if(millis() - lastUpdated > 2000)
  {
    float temp = getTemperature();
    Serial.println(String("the temp is: ") + temp);

    if(temp > 50){
      Blynk.virtualWrite(V0, 1);
      makeNotificationFlame();
    }else{
      Blynk.virtualWrite(V0, 0);  
    }
    delay(10);
    lastUpdated = millis();
  }
}
